/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package defectmover;


import TestTrack_Interface.*;
/**
 *
 * @author cremerf
 */
public class Engine {
    protected Ttsoapcgi ttsoapcgi = new Ttsoapcgi_Impl();
    protected TtsoapcgiPortType_Stub _ttsoapcgi = (TtsoapcgiPortType_Stub)(new Ttsoapcgi_Impl().getTtsoapcgi());
    protected String srcProject;
    protected String dstProject;
    protected String currProject;
    protected String ttServer;
    protected long ttCookie;
    protected long dstCookie;
    protected long srcCookie;
    protected String ttUser;
    protected String ttPassword;

    protected String sresult = "";
    protected long addResult = -1;
    protected long deleteResult = -1;
    
    
    public Engine()
    {
        Config config = new Config();
        srcProject = "";
        dstProject = "";
        ttCookie = 0;
        dstCookie = 0;
        srcCookie = 0;
        ttUser = config.GetTTUser();
        ttPassword = config.GetTTPassword();
        ttServer = config.GetTTServer();
        System.out.println(ttServer + ", " + ttUser + ", " + ttPassword);


        
        try 
        {
            _ttsoapcgi._setProperty(javax.xml.rpc.Stub.ENDPOINT_ADDRESS_PROPERTY, ttServer);
        }
        catch(Exception ex)
        {
	    
        }
    }
      
    public boolean Login(String ttProj)
    {
        boolean result = false;
        try
        {
            //Get list of proejcts for user
            CProject[] ttProjects = _ttsoapcgi.getProjectList(ttUser, ttPassword);
            CProject ttProject = null;
            //Loop until we find the one we want
            for (int i=0; i<ttProjects.length;i++)
            {
                if (ttProjects[i].getDatabase().getName().equals(ttProj))
                {
                    ttProject = ttProjects[i];
                }
                
            }
            if (ttProject != null)
            {
                ttCookie = _ttsoapcgi.projectLogon(ttProject, ttUser, ttPassword);
                if (ttCookie > 0)
                {
                    //Return true only if we have a valid session
                    result = true; 
                }
            }
         }         
         catch(Exception ex) 
         {
             java.util.logging.Logger.getLogger(TestTrack_Interface.Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
         }
         return result;
    }
    public boolean Logout(long cookie)
    {
        boolean result = false;
        if (cookie > 0)
        {
            try
            {
                _ttsoapcgi.databaseLogoff(cookie);      
                result = true;
            }
            catch(java.rmi.RemoteException ex)
            {
                result = false;
            }
           
        }
        return result;
    }
 
    public CRecordListSoap GetDefecList(String ttFilter, long cookie)
    {
        //For performance reasons, we only need to get the fields that we need
        //In this case, we only care about the defect number
        CTableColumn[] ttColumns = new CTableColumn[1];
        //We need to instantiate each column (you'll get a null exception if you don't)
        ttColumns[0] = new CTableColumn();
        //After you instantiate the column, then give it the name
        ttColumns[0].setName("Number");
        
                //Define our variable that will hold the defects
        //I am defining it here because I will use it outside of the 
        //embedded try catch below
        CRecordListSoap ttRecords = new CRecordListSoap();
              
        try
        {
            //Get defect table name
            CDatabaseTable[] ttTables = _ttsoapcgi.getTableList(cookie);
            //Populate the crl variable
            ttRecords = _ttsoapcgi.getRecordListForTable(cookie, ttTables[0].getName(), ttFilter,ttColumns  );
         
        }
        catch (Exception fcc)
        {
            java.util.logging.Logger.getLogger(Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, fcc);
        }
        return ttRecords;
        
        
    }
    //method that moves a defect
    public String MoveDefect(long dNum)
    {

        sresult = "";
        addResult = -1;
        deleteResult = -1;
        try
        {
            //get the defect
            CDefect m_Defect = _ttsoapcgi.getDefect(srcCookie, dNum, "", true);
            try
            {
                //try to add it
                addResult = _ttsoapcgi.addDefect(dstCookie, m_Defect);
            }
            catch(Exception fcc)
            {
                addResult = -1;
            }
            //if successful add, addResult should be the record id of the new defect (i.e., not -1)
            if (addResult != -1)
            {
                try
                {
                    deleteResult = _ttsoapcgi.deleteDefect(srcCookie, dNum, "");
                }
                catch (Exception fcc)
                {
                    deleteResult = -1;
                }
            }
            else
            {
                sresult = "Unable to add defect";
            }
            if (deleteResult == -1)
            {
                sresult = "Unable to delete defect";
            }
                  
            
        }
        catch(Exception fcc)
        {
        }
        return sresult;
    }
    public String MoveSingleDefect(long dNum)
    {
        sresult = "";
        addResult = -1;
        deleteResult = -1;
        
        //Login to source proejct
        if (Login(srcProject))
        {
           srcCookie = ttCookie;

           //Log in to the destination project
           if (Login(dstProject))
           {
               dstCookie = ttCookie;
               //if we can't log in to the destination project, can't go on, let user know.
               if (dstCookie != srcCookie)
               {
                    System.out.println("Moving Defect " + dNum);
                    MoveDefect(dNum);
                    Logout(srcCookie);
                    Logout(dstCookie);
                }
                if ((addResult != -1)&&(deleteResult != -1)&&(sresult.equals("")))
                {
                    sresult = "Success!";

                }
            }
            else
            {
                sresult = "Unable to log in to destination proejct";
            }
            System.out.println(sresult);
        }
        else
        {
            sresult = "Unable to log in to the source project!";
        }
        return sresult;
    }
    public String MoveMultipleDefects(String m_Filter)
    {
        sresult = "";
        //Try to log in to source project
        if (Login(srcProject))
        {
           srcCookie = ttCookie;
           //if succesful, we log in to destinatino project
           if (Login(dstProject))
            {
                dstCookie = ttCookie;
                //Let's just make sure that for some crazy reason both sessions have the same cookie
                if (dstCookie != srcCookie)
                {
                    //Get list of defects
                    CRecordListSoap defectList = GetDefecList(m_Filter, srcCookie);
                    //Check if we get any defects back
                    if (defectList == null)
                    {
                        sresult = "No defects returned by filter, are you sure there are defects to move?";
                    }
                    else
                    {
                        //Get the rows from the defect list
                        CRecordRowSoap[] defectRows = defectList.getRecords();
                        //For each row, move the defect
                        for (int i = 0; i < defectRows.length;i++)
                        {
                            System.out.println("moving defect " + defectRows[i].getRow()[0].getValue());
                            MoveDefect(Long.valueOf(defectRows[i].getRow()[0].getValue()));
                            if (sresult.equals(""))
                            {
                                sresult = "Done!";
                            }
                            System.out.println(sresult);
                    
                        }
                    }
                    Logout(srcCookie);
                    Logout(dstCookie);
                }
            }
            else
            {
                sresult = "Unable to log in to destination project";

            }
            
            
        }
        else
        {
            sresult = "Unable to log in to source project";
        }
        System.out.println(sresult);
        return sresult;
    }
        
    
    

}