/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package defectmover;


import testtrack_Interface.*;
/**
 *
 * @author cremerf
 */
public class Engine {
    protected TtsoapcgiPortType _ttsoapcgi;
    protected String srcProject;
    protected String dstProject;
    protected String currProject;
    protected long ttCookie;
    protected String ttUser;
    protected String ttPassword;
    
    public Engine()
    {
        srcProject = "";
        dstProject = "";
        ttCookie = 0;
        ttUser = "Administrator";
        ttPassword = "password";
        
        try 
        {
         Ttsoapcgi ttsoapcgi = new Ttsoapcgi_Impl();
         //the _ttsoapcgi is what we'll use to make all the calls
	 _ttsoapcgi = ttsoapcgi.getTtsoapcgi();
        }
        catch(javax.xml.rpc.ServiceException ex)
        {
	    java.util.logging.Logger.getLogger(Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
    }
    public void SetProject(String strProject)
    {
        currProject = strProject;
    }
    public String GetProject()
    {
        return currProject;
    }
    public long GetCookie()
    {
        return ttCookie;
    
    }
    public boolean Login()
    {
         boolean result = false;
        //First we need to build the project object
        //Create the database object and set its name
        CDatabase ttDatabase = new CDatabase();
        ttDatabase.setName(currProject);
        //Create the project options object
        CProjectDataOption[] ttProjOps = new CProjectDataOption[2];
        //Allow TestTrack Pro access
        ttProjOps[0] = new CProjectDataOption();
        ttProjOps[0].setName("TestTrack Pro");
        //Allow TestTrack TCM access
        ttProjOps[1] = new CProjectDataOption();
        ttProjOps[1].setName("TestTrack TCM");
        //Now create the project object
        CProject ttProj = new CProject();
        ttProj.setDatabase(ttDatabase);
        ttProj.setOptions(ttProjOps);
        
        //Now we can try to log in
        
        try
        { // This code block invokes the Ttsoapcgi:projectLogon operation on web service
	    
	    ttCookie = _ttsoapcgi.projectLogon(ttProj, ttUser, ttPassword);
            if (ttCookie > 0)
            {
                result = true; 
            }
         }
         
         catch(Exception ex) 
         {
	     java.util.logging.Logger.getLogger(testtrack_Interface.Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
         }

         return result;
        
        
    }
    public boolean Logout()
    {
        boolean result = false;
        if (ttCookie > 0)
        {
            try
            {
                _ttsoapcgi.databaseLogoff(ttCookie);      
                ttCookie = 0;
                result = true;
            }
            catch(java.rmi.RemoteException ex)
            {
                result = false;
            }
           
        }
        return result;
    }
   
    
    public CDefect GetDefect(long defNum)
    {
        CDefect a_Defect = new CDefect();
        try
        {        
           a_Defect = _ttsoapcgi.getDefect(ttCookie,defNum,"",true);
        }
        catch(java.rmi.RemoteException ex)
        {
	    java.util.logging.Logger.getLogger(Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        return a_Defect;
        
    }
    public int DeleteDefect(long defNum)
    {
        int retCode = 0;
        try
        {        
           retCode = _ttsoapcgi.deleteDefectByRecordID(ttCookie, defNum);
        }
        catch(java.rmi.RemoteException ex)
        {
	    java.util.logging.Logger.getLogger(Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        return retCode;
    }
    public long AddDefect(CDefect defToAdd)
    {
        long saveResult = -1;
        try
        {
           saveResult = _ttsoapcgi.addDefect(ttCookie, defToAdd);
        }
        catch(Exception fcc)
        {
            saveResult = -1;
        }
        return saveResult;
    }
    public CRecordListSoap GetDefecList(String ttFilter)
    {
        CTableColumn[] m_Columns = new CTableColumn[1];
        //We need to instantiate each column (you'll get a null exception if you don't)
        
            m_Columns[0] = new CTableColumn();
        //After you instantiate the column, then give it the name
            m_Columns[0].setName("Number");
        
        
        //Define our variable that will hold the defects
        //I am defining it here because I will use it outside of the 
        //embedded try catch below
        CRecordListSoap ttRecords = new CRecordListSoap();
              
        try
        {
            //Get defect table name
            CDatabaseTable[] ttColumns = _ttsoapcgi.getTableList(ttCookie);
            //Populate the crl variable
            ttRecords = _ttsoapcgi.getRecordListForTable(ttCookie, ttColumns[0].getName(), ttFilter,m_Columns  ); 
         
        }
        catch (Exception fcc)
        {
            java.util.logging.Logger.getLogger(Ttsoapcgi.class.getName()).log(java.util.logging.Level.SEVERE, null, fcc);
        }
        return ttRecords;
        
        
    }
    public String MoveSingleDefect(long dNum)
    {
        String result = "";
        long addResult = -1;
        long deleteResult = -1;
        
        SetProject(srcProject);
        if (Login())
        {
            try
            {
                CDefect m_Defect = _ttsoapcgi.getDefect(ttCookie, dNum, "", false);
                if (Logout())
                {
                    SetProject(dstProject);
                    if (Login())
                    {
                        try
                        {
                            addResult = _ttsoapcgi.addDefect(ttCookie, m_Defect);
                        }
                        catch(Exception fcc)
                        {
                            addResult = -1;
                        }
                        Logout();
                        SetProject(srcProject);
                        if (Login())
                        {
                            try
                            {
                            deleteResult = _ttsoapcgi.deleteDefect(ttCookie, dNum, "");
                            
                            }
                            catch (Exception fcc)
                            {
                                deleteResult = -1;
                            }
                        }
                        Logout();
                    }
                    else
                    {
                        result = "There was a problem loggin in";                         
                    }
                }
                
            }
            catch (Exception fcc)
            {
                result = "There was a problem getting defect" + dNum;
            }
            
            
        }
        else
        {
            result = "There was a problem loggin in";
        }
        if ((addResult != -1)&&(deleteResult != -1)&&(result.equals("")))
        {
            result = "Success!";
        }
        return result;
    }
    public String MoveMultipleDefects(String m_Filter)
    {
        String result = "";
        if(Login())
        {
            CRecordListSoap m_List = GetDefecList(m_Filter);
            CRecordRowSoap[] defect = m_List.getRecords();
            for (int i = 0; i < defect.length;i++)
            {
                MoveSingleDefect(Long.valueOf(defect[i].toString()));
                System.exit(9);
                
            }
        }
        return result;
    }
    
    

}